<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des ministres n'ont pas pu être chargées."
    />
    <template v-else-if="followUpMinistresCounts">
      <h2 class="fr-h5">Ministres</h2>
      <p>
        Pourcentage calculé sur le nombre total
        {{ collection === 'help_requests' ? 'de demandes' : "d'entretiens" }}
      </p>
      <StatsList
        v-if="followUpMinistresCounts.length"
        :total-count="totalCount"
        :stats="followUpMinistresCounts"
      />
      <p v-else>{{ emptyResultMessage }}</p>
    </template>
  </div>
</template>

<script setup>
  import { AlertType } from '~~/utils/constants/alert'
  import { COLLECTION_COLORS } from '~~/utils/constants/chart'
  import { MINISTRE_OPTIONS } from '~~/utils/constants/ministry'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { labelOrUnprovided } from '~~/utils/stats'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    totalCount: {
      type: Number,
      required: true
    },
    collection: {
      type: String,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: followUpMinistresCounts,
    pending,
    error
  } = useLazyAsyncData(
    `${props.collection}FollowUpMinistresCounts`,
    loadFollowUpMinistresCounts,
    {
      server: false
    }
  )

  const emptyResultMessage = computed(() => {
    return `Commencez à créer des ${
      props.collection === 'help_requests'
        ? "instructions de demande d'aides"
        : "synthèses d'entretien"
    } dans les fiches de bénéficiaires pour voir apparaître les statistiques de la répartition des ministres.`
  })

  async function loadFollowUpMinistresCounts() {
    // NOTE: It is not using `count` agreggation due to a Directus bug - See https://github.com/directus/directus/discussions/16992
    const res = await $getItems(props.collection, {
      groupBy: 'ministre',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const ministresCounts = res.data.data.map(
        ({ ministre, countDistinct }) => ({
          key: ministre,
          label: labelOrUnprovided(ministre, MINISTRE_OPTIONS),
          color: COLLECTION_COLORS[props.collection],
          count: parseInt(countDistinct.id)
        })
      )
      ministresCounts.sort((a, b) => b.count - a.count)
      return ministresCounts
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
